

#include "handles_Handles_NativeHandleOverTime.h"
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>


// keep the reference for other thread
static volatile jobject reference;
// keep the env refernece for later
static JNIEnv* envReference;
// vm refernece
static JavaVM *jvm;

void *periodicCheckIfPrint(){
    
    JNIEnv *env;
    jint rs = (*jvm)->AttachCurrentThread(jvm, &env, NULL);
    if(rs != JNI_OK){
        return NULL;
    }
    envReference = env;
    int everNonNull = 0;
    
    while(1){
            // wait 500 milli second
            usleep(500*1000);
            if(reference==NULL && everNonNull){
                    printf("We are done...\n");fflush(stdout);
                    (*jvm)->DetachCurrentThread(jvm);
                    return NULL;
            }
            if(reference==NULL){
                    continue;
            }
            everNonNull = 1;
            jclass cls = (*envReference)->GetObjectClass(envReference, reference);
            if(cls == NULL){
                return NULL;
            }
            const char* sig = "()V";
            
            jmethodID sayMethod = (*envReference)->GetMethodID(envReference, cls, "saySth", sig);
            if(sayMethod==0){
                    return NULL;
            }
            
            (*envReference)->CallVoidMethod(envReference, reference, sayMethod);
            fflush(stdout);
    }
}

/*
 * Class:     handles_Handles_NativeHandleOverTime
 * Method:    swallowObject
 * Signature: (Lhandles/Handles/A;)V
 */
JNIEXPORT void JNICALL Java_handles_Handles_00024NativeHandleOverTime_swallowObject
  (JNIEnv* env, jobject thisObject, jobject referenceToA){
      
      // get a hold of the vm
      (*env)->GetJavaVM(env, &jvm);
      // safe the refernece for other thread
      reference = (*env)->NewGlobalRef(env, referenceToA);
      
      pthread_t p1;
      pthread_create (&p1, NULL, periodicCheckIfPrint, NULL);  
      
      
      
}

/*
 * Class:     handles_Handles_NativeHandleOverTime
 * Method:    giveItFree
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_handles_Handles_00024NativeHandleOverTime_giveItFree
  (JNIEnv* env, jobject thisObject) {

      printf("Second native call \n");      fflush(stdout);
      if(reference!=NULL){
        (*envReference)->DeleteGlobalRef(env,reference);
        reference = NULL;
        printf("Setting refernce to NULL\n");fflush(stdout);
      }
}


