package callbacks;

public class CallBack {

	static class A {
		static {
			System.load("CallBack$A_impl.so");
		}

		native void callBackToDynamicMethodOfB(B b);
	}

	static class B {
		void b() {
			System.out.println("Got called...");
			// dumping the current stack trace
			for (StackTraceElement ste : Thread.currentThread().getStackTrace()) {
				System.out.println("\t" + ste);
			}
		}
	}

	public static void main(String[] args) {
		B b = new B();
		b.b();

		new A().callBackToDynamicMethodOfB(b);
	}
}
